OpenSSL::HMAC - Crystal 1.20.1

# class OpenSSL::HMAC

- OpenSSL::HMAC
- Reference
- Object

##
Overview

Allows computing Hash-based Message Authentication Code (HMAC).

It is a type of message authentication code (MAC) involving a hash function in combination with a key.

HMAC can be used to verify the integrity of a message as well as the authenticity.

See also RFC2104.

##
Defined in:

openssl/hmac.cr

##
Class Method Summary

- .digest(algorithm : OpenSSL::Algorithm, key, data) : Bytes

  Returns the HMAC digest of data using the secret key.

- .hexdigest(algorithm : OpenSSL::Algorithm, key, data) : String

  Returns the HMAC digest of data using the secret key, formatted as a hexadecimal string.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Class Method Detail

def self.digest(algorithm : OpenSSL::Algorithm, key, data) : Bytes #

Returns the HMAC digest of data using the secret key.

It may contain non-ASCII bytes, including NUL bytes.

algorithm specifies which `OpenSSL::Algorithm` is to be used.

def self.hexdigest(algorithm : OpenSSL::Algorithm, key, data) : String #

Returns the HMAC digest of data using the secret key, formatted as a hexadecimal string. This is necessary to safely transfer the digest where binary messages are not allowed.

See also `#digest`.